## mongrel2 1.12.2

=== Makefile ===
CFLAGS?=-g -O2
CFLAGS += -Wall -Wextra -Wno-implicit-fallthrough -Wno-unused-const-variable -I./src -DNDEBUG -D_FILE_OFFSET_BITS=64 -pthread
CFLAGS += ${OPTFLAGS}
LIBS+=-lzmq -ldl -lsqlite3 -lmbedtls -lmbedx509 -lmbedcrypto
PREFIX?=/usr/local

get_objs = $(addsuffix .o,$(basename $(wildcard $(1))))

ASM=$(wildcard src/**/*.S src/*.S)
RAGEL_TARGETS=src/state.c src/http11/http11_parser.c
SOURCES=$(wildcard src/**/*.c src/*.c) $(RAGEL_TARGETS)
OBJECTS=$(patsubst %.c,%.o,${SOURCES}) $(patsubst %.S,%.o,${ASM})
OBJECTS_NOEXT=$(filter-out ${OBJECTS_EXTERNAL},${OBJECTS})
LIB_SRC=$(filter-out src/mongrel2.c,${SOURCES})
LIB_OBJ=$(filter-out src/mongrel2.o,${OBJECTS})
TEST_SRC=$(wildcard tests/*_tests.c)
TESTS=$(patsubst %.c,%,${TEST_SRC})
MAKEOPTS=OPTFLAGS="${CFLAGS} ${NOEXTCFLAGS} ${OPTFLAGS}" LIBS="${LIBS}" DESTDIR="${DESTDIR}" PREFIX="${PREFIX}"

all: bin/mongrel2 tests m2sh procer

${OBJECTS_NOEXT}: CFLAGS += ${NOEXTCFLAGS}
${OBJECTS}: | builddirs

.PHONY: builddirs
builddirs:
	@mkdir -p build
	@mkdir -p bin

bin/mongrel2: build/libm2.a src/mongrel2.o
	$(CC) $(CFLAGS) $(LDFLAGS) src/mongrel2.o -o $@ $< $(LIBS)

build/libm2.a: CFLAGS += -fPIC
build/libm2.a: ${LIB_OBJ}
	ar rcs $@ ${LIB_OBJ}
	ranlib $@

clean:
	rm -rf build bin lib ${OBJECTS} ${TESTS} tests/config.sqlite
	rm -f tests/perf.log 
	rm -f tests/test.pid 
	rm -f tests/tests.log 
	rm -f tests/empty.sqlite 
	rm -f tools/lemon/lemon
	rm -f tools/m2sh/tests/tests.log 
	rm -rf release-scripts/output
	find . \( -name "*.gcno" -o -name "*.gcda" \) -exec rm {} \;
	${MAKE} -C tools/m2sh OPTLIB=${OPTLIB} clean
	${MAKE} -C tools/filters OPTLIB=${OPTLIB} clean
	${MAKE} -C tests/filters OPTLIB=${OPTLIB} clean
	${MAKE} -C tools/config_modules OPTLIB=${OPTLIB} clean
	${MAKE} -C tools/procer OPTLIB=${OPTLIB} clean

pristine: clean
	sudo rm -rf examples/python/build examples/python/dist examples/python/m2py.egg-info
	sudo find . -name "*.pyc" -exec rm {} \;
	${MAKE} -C docs/manual clean
	cd docs/ && ${MAKE} clean
	${MAKE} -C examples/kegogi clean
	rm -f logs/*
	rm -f run/*
	${MAKE} -C tools/m2sh pristine
	${MAKE} -C tools/procer pristine

.PHONY: tests
tests: tests/config.sqlite ${TESTS} test_filters filters config_modules
	sh ./tests/runtests.sh

tests/config.sqlite: src/config/config.sql src/config/example.sql src/config/mimetypes.sql
	sqlite3 $@ < src/config/config.sql
	sqlite3 $@ < src/config/example.sql
	sqlite3 $@ < src/config/mimetypes.sql

$(TESTS): %: %.c build/libm2.a
	$(CC) $(CFLAGS) -o $@ $< build/libm2.a $(LIBS)

src/state.c: src/state.rl src/state_machine.rl
src/http11/http11_parser.c: src/http11/http11_parser.rl
src/http11/httpclient_parser.c: src/http11/httpclient_parser.rl

check:
	@echo Files with potentially dangerous functions.
	@egrep '[^_.>a-zA-Z0-9](str(n?cpy|n?cat|xfrm|n?dup|str|pbrk|tok|_)|stpn?cpy|a?sn?printf|byte_)' $(filter-out src/bstr/bsafe.c,${SOURCES})

m2sh: build/libm2.a
	${MAKE} ${MAKEOPTS} -C tools/m2sh all

procer: build/libm2.a
	${MAKE} ${MAKEOPTS} -C tools/procer all

test_filters: build/libm2.a
	${MAKE} ${MAKEOPTS} -C tests/filters all

filters: build/libm2.a
	${MAKE} ${MAKEOPTS} -C tools/filters all

config_modules: build/libm2.a
	${MAKE} ${MAKEOPTS} -C tools/config_modules all

# Try to install first before creating target directory and trying again
install: all
	install bin/mongrel2 $(DESTDIR)/$(PREFIX)/bin/ \
	    || ( install -d $(DESTDIR)/$(PREFIX)/bin/ \
	        && install bin/mongrel2 $(DESTDIR)/$(PREFIX)/bin/ )
	${MAKE} ${MAKEOPTS} -C tools/m2sh install
	${MAKE} ${MAKEOPTS} -C tools/config_modules install
	${MAKE} ${MAKEOPTS} -C tools/filters install
	${MAKE} ${MAKEOPTS} -C tools/procer install

examples/python/mongrel2/sql/config.sql: src/config/config.sql src/config/mimetypes.sql
	cat src/config/config.sql src/config/mimetypes.sql > $@

ragel:
	ragel -G2 src/state.rl
	ragel -G2 src/http11/http11_parser.rl
	ragel -G2 src/handler_parser.rl
	ragel -G2 src/http11/httpclient_parser.rl

%.o: %.S
	$(CC) $(CFLAGS) -c $< -o $@

valgrind:
	VALGRIND="valgrind --log-file=/tmp/valgrind-%p.log" ${MAKE}
strace:
	VALGRIND="strace" ${MAKE}

%.o: %.S
	$(CC) $(CFLAGS) -c $< -o $@

coverage: NOEXTCFLAGS += -fprofile-arcs -ftest-coverage
coverage: LIBS += -lgcov
coverage: LDFLAGS += -fprofile-arcs
coverage: clean all coverage_report

coverage_report:
	rm -rf tests/m2.zcov tests/coverage
	zcov-scan tests/m2.zcov
	zcov-genhtml --root $(CURDIR) tests/m2.zcov tests/coverage
	zcov-summarize tests/m2.zcov

system_tests:
	./tests/system_tests/curl_tests
	./tests/system_tests/chat_tests

manual:
	dexy
	cp docs/manual/Makefile output/docs/manual/
	cp docs/manual/pastie.sty output/docs/manual/
	${MAKE} -C output/docs/manual clean book-final.pdf
	rm -rf output/docs/manual/*.dvi output/docs/manual/*.pdf
	${MAKE} -C output/docs/manual book-final.pdf
	${MAKE} -C output/docs/manual draft

tarball:
	sh maketar.sh mongrel2-${VERSION}

release: tarball
	#git archive --format=tar --prefix=mongrel2-${VERSION}/ v${VERSION} | bzip2 -9 > mongrel2-${VERSION}.tar.bz2
	scp mongrel2-${VERSION}.tar.bz2 ${USER}@mongrel2.org:/var/www/mongrel2.org/static/downloads/
	md5sum mongrel2-${VERSION}.tar.bz2
	curl http://mongrel2.org/static/downloads/mongrel2-${VERSION}.tar.bz2 | md5sum

netbsd: OPTFLAGS += -I/usr/local/include -I/usr/pkg/include
netbsd: LDFLAGS += -L/usr/local/lib -L/usr/pkg/lib
netbsd: LIBS=-lzmq -lsqlite3 $(LDFLAGS)
netbsd: dev


freebsd: OPTFLAGS += -I/usr/local/include
freebsd: LDFLAGS += -L/usr/local/lib -pthread
freebsd: LIBS=-lzmq -lsqlite3 $(LDFLAGS)
freebsd: all

openbsd: OPTFLAGS += -I/usr/local/include
openbsd: LDFLAGS += -L/usr/local/lib -pthread
openbsd: LIBS=-lzmq -lsqlite3 $(LDFLAGS)
openbsd: all

solaris: OPTFLAGS += -I/usr/local/include
solaris: LDFLAGS += -L/usr/local/lib -R/usr/local/lib -lsocket -lnsl -lsendfile
solaris: LDFLAGS += -L/lib -R/lib
solaris: all


macports: OPTFLAGS += -I/opt/local/include
macports: LDFLAGS += -L/opt/local/lib -undefined dynamic_lookup
macports: all

brew: OPTFLAGS += -I/usr/local/include
brew: LDFLAGS += -L/usr/local/lib -undefined dynamic_lookup
brew: all

=== docs/Makefile ===
# $Id: Makefile.gcc,v 1.17 1999/11/22 03:19:24 kaz Exp $
# $Name: kazlib_1_20 $

kazlib: kazlib.pdf

kazlib.pdf: kazlib.dvi
	dvipdf kazlib.dvi

kazlib.dvi: kazlib.ltx kazlib.toc kazlib.ind
	latex kazlib.ltx

kazlib.ind: kazlib.idx kazlib.ist
	makeindex -s kazlib.ist kazlib.idx

kazlib.toc: kazlib.ltx
	latex kazlib.ltx

kazlib.idx: kazlib.ltx
	latex kazlib.ltx

clean:
	rm -f kazlib.aux kazlib.log kazlib.dvi kazlib.toc kazlib.idx kazlib.ind kazlib.ilg

=== docs/manual/Makefile ===
HTLATEX ?= htlatex
JUNK_FILES=book-final* *.aux *.log styles/*.aux
SOURCE=book
WEBSITE=$(USER)@mongrel2.org:/var/www/mongrel2.org/static/
FINAL=book-final

draft: book-final.dvi
	$(HTLATEX) book-final.tex "book,index=1,2,next,fn-in"

book-final.dvi:
	cp $(SOURCE).tex book-final.tex
	latex -halt-on-error book-final.tex

book-final.pdf: book-final.dvi
	dvipdf book-final.dvi

view: book-final.pdf
	evince book-final.pdf

clean:
	rm -rf $(JUNK_FILES)
	find . -name "*.aux" -exec rm {} \;

release: clean book-final.pdf draft book-final.pdf sync

sync:
	rsync -vz $(FINAL).pdf $(WEBSITE)/mongrel2-manual.pdf
	rsync -vz $(FINAL).html $(WEBSITE)/mongrel2-manual.html
	rsync -vz $(FINAL).css $(FINAL)*.html $(WEBSITE)/

=== docs/site/Makefile ===
WEBSITE=~/mongrel2.org/site-root

all:
	rsync -a --delete assets/ output/
	mkdir -p output/manual
	lua gensite.lua output
	bash -c 'cp -a ../../output/docs/manual/*.{html,css} output/manual'

clean:
	rm -rf output

sync: all
	rsync -avz output/* $(WEBSITE)/

=== examples/kegogi/Makefile ===
CFLAGS=-g -I../../src -Isrc -Wall -Wextra
LIBS=-lzmq -lsqlite3

all: kegogi

install: all
	sudo install build/kegogi /usr/local/bin/

kegogi: src/kegogi.o src/fuzzrnd.o src/kegogi_parser.o src/httpclient.o src/param.o src/kegogi_lexer.o src/kegogi_tokens.o
	mkdir -p build
	$(CC) ${CFLAGS} -o build/kegogi src/kegogi.o src/kegogi_parser.o src/kegogi_lexer.o src/fuzzrnd.o src/httpclient.o src/param.o src/kegogi_tokens.o ${LIBS} ../../build/libm2.a

src/kegogi_lexer.o: src/kegogi_lexer.c
	$(CC) $(CFLAGS) -c src/kegogi_lexer.c -o src/kegogi_lexer.o

src/kegogi_lexer.c: src/kegogi_lexer.rl src/kegogi_parser.h
	ragel src/kegogi_lexer.rl -C -o src/kegogi_lexer.c

src/kegogi_parser.c: src/kegogi_parser.y src/kegogi_parser_extra.c lemon
	./lemon src/kegogi_parser.y
	cat src/kegogi_parser_extra.c >> src/kegogi_parser.c
	echo "foo"
clean:
	rm -f src/*.o build/*

=== tools/config_modules/Makefile ===
PREFIX?=/usr/local
CFLAGS=-I../../src -I../../src/mbedtls/include $(OPTFLAGS) -fPIC -shared -nostartfiles -L../../build
LDFLAGS=$(OPTLIBS)

MONGO_SRC = mongo-c-driver/src/bson.c \
            mongo-c-driver/src/encoding.c \
            mongo-c-driver/src/gridfs.c \
            mongo-c-driver/src/md5.c \
            mongo-c-driver/src/mongo.c \
            mongo-c-driver/src/numbers.c \
            mongo-c-driver/src/env_posix.c
MONGO_CFLAGS = -fPIC -Imongo-c-driver/src -DMONGO_HAVE_STDINT

all: null.so zmq.so

.PHONY: fetch_mongo_c_driver
fetch_mongo_c_driver:
	if test ! -d mongo-c-driver; then git clone https://github.com/mongodb/mongo-c-driver.git; fi
	cd mongo-c-driver && git checkout v0.6
	

mongodb.so: CFLAGS += $(MONGO_CFLAGS)
mongodb.so: fetch_mongo_c_driver
mongodb.so: mongodb.c
	$(CC) $(CFLAGS) -c $(MONGO_SRC)
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< bson.o encoding.o gridfs.o md5.o mongo.o env_posix.o numbers.o ../../build/libm2.a

%.so : %.c
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< ../../build/libm2.a

clean:
	rm -f *.o *.so
	rm -Rf mongo-c-driver

install:
	install -d $(DESTDIR)/$(PREFIX)/lib/mongrel2/config_modules/
	install *.so $(DESTDIR)/$(PREFIX)/lib/mongrel2/config_modules/

=== tools/filters/Makefile ===
PREFIX?=/usr/local
CFLAGS=-I../../src -I../../src/mbedtls/include $(OPTFLAGS) -g -fPIC -shared -nostartfiles -L../../build
LDFLAGS=$(OPTLIBS)

all: null.so rewrite.so sendfile.so


%.so : %.c
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $< ../../build/libm2.a

clean:
	rm -f *.so

install:
	install -d $(DESTDIR)/$(PREFIX)/lib/mongrel2/filters/
	install *.so $(DESTDIR)/$(PREFIX)/lib/mongrel2/filters/

=== tools/m2sh/Makefile ===
CFLAGS=-DNDEBUG -DNO_LINENOS -pthread -g -I../../src -Isrc -Wall $(OPTFLAGS)
LIBS=-lzmq -lsqlite3 ../../build/libm2.a $(OPTLIBS)

PREFIX?=/usr/local
SOURCES=$(wildcard src/*.c src/**/*.c)
OBJECTS=$(patsubst %.c,%.o,${SOURCES})
TEST_SRC=$(wildcard tests/*.c)
TESTS=$(patsubst %.c,%,${TEST_SRC})
LIB_SRC=$(filter-out src/m2sh.c,${SOURCES})
LIB_OBJ=$(filter-out src/m2sh.o,${OBJECTS})

all: ../lemon/lemon tests build/m2sh

dev: CFLAGS=-g -Wall -Wextra -Isrc -I../../src $(OPTFLAGS)
dev: all

install: build/m2sh
	install build/m2sh ${DESTDIR}${PREFIX}/bin

build/libm2sh.a: ${LIB_OBJ}
	mkdir -p build
	ar rcs $@ ${LIB_OBJ}
	ranlib $@

build/m2sh: ../lemon/lemon ../../build/libm2.a ${OBJECTS}
	mkdir -p build
	$(CC) $(CFLAGS) -o build/m2sh ${OBJECTS} ../../build/libm2.a $(LIBS)

../lemon/lemon: ../lemon/lemon.c
	$(CC) -O2 ../lemon/lemon.c -o ../lemon/lemon

tests: build/libm2sh.a ${TESTS}
	sh ./tests/runtests.sh

%.c: %.y
	../lemon/lemon -s $< 

%.c: %.rl
	ragel -G2 $<

$(TESTS): %: %.c build/libm2sh.a
	$(CC) $(CFLAGS) -o $@ $< build/libm2sh.a ../../build/libm2.a $(LIBS)

../../build/libm2.a:
	cd ../.. && make clean all

clean:
	rm -rf src/*.o src/*/*.o build tests/*_tests tests/*.o

pristine: clean
	rm -f ../lemon/lemon

netbsd: OPTFLAGS=-I/usr/local/include -I/usr/pkg/include
netbsd: OPTLIBS=-L/usr/local/lib -L/usr/pkg/lib
netbsd: dev

freebsd: OPTFLAGS=-I/usr/local/include
freebsd: OPTLIBS=-L/usr/local/lib
freebsd: dev

=== tools/procer/Makefile ===
CFLAGS=-DNDEBUG -pthread -g -I../../src -Wall $(OPTFLAGS)
PREFIX?=/usr/local
LIBS?=-lzmq 
SOURCES=$(wildcard *.c)
OBJECTS=$(patsubst %.c,%.o,${SOURCES})

all: procer


procer: ../../build/libm2.a ${OBJECTS}
	$(CC) $(OPTFLAGS) $(OPTLIBS) -o $@ ${OBJECTS} ../../build/libm2.a ${LIBS}

clean:
	rm -f *.o procer

pristine:
	rm -f *.o procer

install: procer
	install procer $(DESTDIR)$(PREFIX)/bin/

=== docs/ru/manual/Makefile ===
PDF=mongrel2-1.1-guide-ru.pdf
JUNK_FILES=book-final.* *.aux *.log styles/*.aux book-final* $(PDF)
SOURCE=book
WEBSITE=zedshaw.com:/someplace

draft: book-final.dvi
	htlatex book-final.tex
	tidy -quiet -ashtml -omit -ic -m book-final.html
	sed -f clean.sed book-final.html > book.wiki

book-final.dvi:
	cp $(SOURCE).tex book-final.tex
	latex -halt-on-error book-final.tex

book-final.pdf: book-final.dvi
	dvipdf book-final.dvi $(PDF)

view: book-final.pdf
	evince book-final.pdf

clean:
	rm -rf $(JUNK_FILES)
	find . -name "*.aux" -exec rm {} \;

release: clean book-final.pdf
	rsync -vz $(FINAL).pdf $(WEBSITE)

pdf: book-final.pdf

=== examples/bbs/html/flash/Makefile ===
default: jsSocket.swf jsSocket2.swf

jsSocket.swf: jsSocket.as
	mtasc jsSocket.as -version 8 -main -mx -header 800:600:31 -swf jsSocket.swf

jsSocket2.swf: JsSocket.hx
	haxe -swf jsSocket2.swf -swf-version 9 -main JsSocket -swf-header 800:600:31

=== debian/changelog ===
mongrel2 (1.12.2-2) unstable; urgency=medium

  * Fix crash when reading websocket packet after deliver task has stopped

 -- Jan Niehusmann <jan@debian.org>  Wed, 15 Jan 2020 20:29:16 +0100

mongrel2 (1.12.2-1) unstable; urgency=medium

  * Update to upstream release 1.12.2:
    Workaround to prevent crashes on large files
    Disable some compiler warnings

 -- Jan Niehusmann <jan@debian.org>  Tue, 23 Jul 2019 00:07:09 +0200

mongrel2 (1.12.0-2) unstable; urgency=medium

  * Build with authbind support
  * Set Standards-Version: 4.3.0

 -- Jan Niehusmann <jan@debian.org>  Tue, 19 Feb 2019 09:21:39 +0100

=== debian/control ===
Source: mongrel2
Section: httpd
Priority: optional
Maintainer: Jan Niehusmann <jan@debian.org>
Build-Depends: debhelper (>= 10.0.0), libzmq3-dev (>= 2.1), libsqlite3-dev (>= 3.0), sqlite3 (>= 3.0), libmbedtls-dev, dpkg-dev (>= 1.16.1~)
Standards-Version: 4.3.0
Homepage: http://mongrel2.org/
Vcs-Git: https://salsa.debian.org/jan/mongrel2.git
Vcs-Browser: https://salsa.debian.org/jan/mongrel2

Package: mongrel2-core
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: programming language agnostic web server (binaries)
 Mongrel2 is an application, programming language, and network
 architecture agnostic web server that focuses on web applications using
 modern browser technologies.
 .
 Mongrel2 supports 17 languages and platforms, HTTP, Flash sockets,
 WebSockets, Long Polling, and many ways to deploy and hack on it.
 .
 This package includes the server binaries but doesn't contain all the
 infrastructure needed to setup a standalone web server.


Package: mongrel2-run
Architecture: all
Depends: mongrel2-core (>= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}, runit, adduser
Description: programming language agnostic web server
 Mongrel2 is an application, programming language, and network
 architecture agnostic web server that focuses on web applications using
 modern browser technologies.
 .
 Mongrel2 supports 17 languages and platforms, HTTP, Flash sockets,
 WebSockets, Long Polling, and many ways to deploy and hack on it.
 .
 This package includes the infrastructure needed to setup a standalone
 web server. Starting mongrel2 at boot is done using runit.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# enable hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

CFLAGS += -std=gnu89 -DAUTHBIND_HELPER=\"/usr/lib/authbind/helper\"

%:
	dh $@

override_dh_auto_install:
	$(MAKE) DESTDIR="$$(pwd)/debian/tmp" PREFIX=/usr install

override_dh_installexamples-arch:
	dh_installexamples
	find "$$(pwd)/debian/mongrel2-core" -name "*.css" -perm /a+x -exec chmod -x "{}" \;
